--- old/usr/src/cmd/svc/startd/graph.c	2012-07-27 03:18:29.275934613 +0400
+++ new/usr/src/cmd/svc/startd/graph.c	2012-07-27 03:18:27.748184158 +0400
@@ -3574,6 +3574,22 @@
 	(void) fork_with_timeout("/usr/bin/pkill -KILL -v -u 0,1,15", 1, 5);
 }
 
+static int
+exec_cmd(char * invoke, char * output)
+{
+	FILE * cmd = popen(invoke, "r");
+	if (! cmd) 
+		return 0;
+	fgets(output, 512, cmd);
+	if (! *output) {
+		pclose(cmd);
+		return 0;
+	}
+	output[strlen(output) - 2] = '\0';
+	pclose(cmd);
+	return 1;
+}
+
 static void
 do_uadmin(void)
 {
@@ -3640,8 +3656,8 @@
 #if defined(__i386)
 		int rc;
 
-		if ((rc = grub_get_boot_args(&fbarg, NULL,
-		    GRUB_ENTRY_DEFAULT)) == 0) {
+		if ((rc = exec_cmd("/sbin/grubadm --number -1 --get-opts", 
+			fbarg.gba_bootargs)) == 0) {
 			mdep = (uintptr_t)&fbarg.gba_bootargs;
 		} else {
 			/*
